#pragma once
#include <iostream>
#include <memory>
#include <vector>
#include <future>
#include <complex>
#include "gdalwarper.h"

#define PI_180 180/3.141592653589793238462643383279;
#define T180_PI 3.141592653589793238462643383279/180;

#define Radians2Degrees(Radians) Radians*PI_180
#define Degrees2Radians(Degrees) Degrees*T180_PI

const long double PI=3.141592653589793238462643383279;
const long double epsilon = 0.000000000000001;
const long double pi = 3.14159265358979323846;
const long double d2r = pi / 180;
const long double r2d = 180 / pi;

const long double a = 6378137.0;		//򳤰
const long double f_inverse = 298.257223563;			//ʵ
const long double b = a - a / f_inverse;
const long double e = sqrt(a * a - b * b) / a;
const long double eSquare = e*e;



int testPP();

using namespace std;
///
/// 
/// 

struct point //     SARӰꣻ
{
	long double x; // γ lat pixel_row
	long double y; //  lon pixel_col
	long double z; // ߳ ati pixel_time
};

struct VectorPoint {
	long double x;
	long double y;
	long double z;
};
/// <summary>
/// γתΪع̲ϵ
/// </summary>
/// <param name="XYZP">γȵ--degree</param>
/// <returns>ͶӰϵ</returns>
inline point LLA2XYZ(point& LLA) {
	long double L = LLA.x * d2r;
	long double B = LLA.y * d2r;
	long double H = LLA.z;

	long double sinB = sin(B);
	long double cosB = cos(B);
	 
	//long double N = a / sqrt(1 - e * e * sin(B) * sin(B));
	long double N = a / sqrt(1 - eSquare * sinB * sinB);
	point result = { 0,0,0 };
	result.x = (N + H) * cosB * cos(L);
	result.y = (N + H) * cosB * sin(L);
	//result.z = (N * (1 - e * e) + H) * sin(B);
	result.z = (N * (1 - eSquare) + H) * sinB;
	return result;
}

/// <summary>
/// ع̲ϵתΪγ
/// </summary>
/// <param name="XYZ">̲ϵ</param>
/// <returns>γ--degree</returns>
point XYZ2LLA(point& XYZ);

/// <summary>
/// ֮XYƽŷʽƽ
/// </summary>
/// <param name="p1"></param>
/// <param name="p2"></param>
/// <returns></returns>
inline long double caldistanceXY(point& p1, point& p2) {
	//return pow(p1.x - p2.x, 2) + pow(p1.y - p2.y, 2);
	return (p1.x - p2.x)* (p1.x - p2.x) + (p1.y - p2.y)* (p1.y - p2.y);
}

/// <summary>
/// ʹ㣬 p1-->p2
/// </summary>
/// <param name="p1">p1</param>
/// <param name="p2">p2</param>
/// <returns></returns>
inline VectorPoint getVector(point& p1, point& p2) {
	VectorPoint result = { 0,0,0 };
	result.x = p2.x - p1.x;
	result.y = p2.y - p1.y;
	result.z = p2.z - p1.z;
	return result;
}

/// <summary>
/// ȡģ
/// </summary>
/// <param name="vector1"></param>
/// <returns>ģ</returns>
inline long double getModule(VectorPoint& vector1) {
	//return sqrt(pow(vector1.x, 2) + pow(vector1.y, 2) + pow(vector1.z, 2));
	return sqrt(vector1.x* vector1.x + vector1.y* vector1.y + vector1.z* vector1.z);
}

inline long double getModuleV1V2(VectorPoint& v1, VectorPoint& v2)
{
	return sqrt((v1.x * v1.x + v1.y * v1.y + v1.z * v1.z) * (v2.x * v2.x + v2.y * v2.y + v2.z * v2.z));
}

/// <summary>
/// нǵĽǶ( Ƕȣ
/// </summary>
/// <param name="vector1"></param>
/// <returns>нǵĽǶ</returns>
inline long double getVectorAngle(VectorPoint& vector1,VectorPoint& vector2) {
	//return Radians2Degrees( acos((vector1.x * vector2.x + vector1.y * vector2.y + vector1.z * vector2.z) / (getModule(vector1) * getModule(vector2))));
	return Radians2Degrees(acos((vector1.x * vector2.x + vector1.y * vector2.y + vector1.z * vector2.z) / (getModuleV1V2(vector1, vector2))));

}


/// <summary>
/// ļнֵ
/// </summary>
/// <param name="vector1"></param>
/// <returns>нǵĽǶ</returns>
inline long double getVectorAngleValue(VectorPoint& vector1, VectorPoint& vector2) {
	//return (vector1.x * vector2.x + vector1.y * vector2.y + vector1.z * vector2.z) / (getModule(vector1) * getModule(vector2));
	return (vector1.x * vector2.x + vector1.y * vector2.y + vector1.z * vector2.z) / (getModuleV1V2(vector1, vector2));
}
/// <summary>
/// 
/// </summary>
/// <param name="V1">1</param>
/// <param name="v2">2</param>
/// <returns>ֵ</returns>
inline long double Vectordot(VectorPoint& V1, VectorPoint& v2) {
	return V1.x * v2.x + V1.y * v2.y + V1.z * v2.z;
}

/// <summary>
/// 
/// </summary>
/// <param name="V1">1</param>
/// <param name="lamda">ϵֵ</param>
/// <returns>֮Ĳֵ</returns>
inline VectorPoint VectordotNumber(VectorPoint& V1, long double lamda) {
	V1.x = V1.x * lamda;
	V1.y = V1.y * lamda; 
	V1.z = V1.z * lamda;
	return V1;
}

/// <summary>
/// 
/// תv1->v2
/// </summary>
/// <param name="v1">v1</param>
/// <param name="v2">v2</param>
/// <returns>˵Ľ</returns>
inline VectorPoint VectorFork(VectorPoint &v1, VectorPoint& v2) {
	VectorPoint result{ 0,0,0 };
	result.x = v1.y * v2.z - v1.z * v2.y;
	result.y =v1.z*v2.x -v1.x * v2.z;
	result.z = v1.x * v2.y - v1.y * v2.x;
	return result;
}


//
// ļ
//

//ļ׼ʽ
// ļֵ           ӦĴ
// DEMļ· str   dem_path
// ģӰ· str sar_sim_path
// ģӰĿ  int
// ģӰĸ  int
// ģӰƥļ· str sar_sim_match_point_x_path
// ģӰƥX· str sar_sim_match_point_x_path
// ģӰƥY· str sar_sim_match_point_y_path
// ģӰƥZ· str sar_sim_match_point_z_path
//  long double sample_f
// б long double R0
// ʼʱ long double  starttime ---UTC ʱ
//  long double
//  long double
// ղοʱ long double TO  ---UTC ʱ  
// ظƵ long double  PRF
// б long double delta_R
// ϵ int 
// ϵ1 long double
// ϵ2 long double
// ....
// ǹģǷΪʽģ int 1 ǡ0 
// ǹģͶʽ  int  4 5
// ǹģʼʱ long double 
// ǹģXֵϵ1 long double
// ....
// ǹģYֵϵ1 long double
// ...
// ǹģZֵϵ1 long double
// ...
// ǹģVxֵϵ1 long double
// ...
// ǹģVyֵϵ1 long double
// ...
// ǹģVzֵϵ1 long double
// ...
// 
//

class ParameterInFile
{
public:
	ParameterInFile(std::string infile_path);
	ParameterInFile(const ParameterInFile& paras);
	~ParameterInFile();
public:
	//
	std::string dem_path; //dem ·
	std::string out_sar_sim_path; // ģsar
	std::string out_sar_sim_dem_path; // ģsar
	std::string out_sar_sim_resampling_path; // ģsar
	std::string out_sar_sim_resampling_rc;
	int sim_height; // ģӰĸ
	int sim_width;
	long double widthspace;// ֱ
	std::string sar_sim_match_point_path; //ģӰĵصx
	std::string sar_sim_match_point_xyz_path; //ģӰĵصx
	int sample_f; //
	long double R0; //б
	long double LightSpeed;//
	long double lamda;//
	long double refrange;// οб
	
	long double delta_R; // б
	long double imgStartTime; //ʼʱ
	long double PRF;// ظ
	long double delta_t;// ʱ
	// 
	int doppler_paramenter_number;// ϵ
	long double* doppler_para;//ϵ
	//ǹģ
	int polySatelliteModel;// ǷΪǶģ
	int polynum;// 
	long double SatelliteModelStartTime;
	long double* polySatellitePara;
};

// ݹģͼǿռλ
struct SatelliteSpacePoint {
	long double x=0;
	long double y=0;
	long double z=0;
	long double vx=0;
	long double vy=0;
	long double vz=0;

};


/// <summary>
/// ǹģͼ
/// </summary>
/// <param name="satelliteTime">ǹʱ</param>
/// <param name="SatelliteModelStartTime">ǹģʼʱ</param>
/// <param name="polySatellitePara">ǹģͲ</param>
/// <param name="polynum">ʽ</param>
/// <returns></returns>
inline SatelliteSpacePoint getSatellitePostion(long double satelliteTime,long double SatelliteModelStartTime,long double* polySatellitePara,int polynum);

/// <summary>
///  ֵģⷨƵֵ
/// </summary>
/// <param name="R">б</param>
/// <param name="LightSpeed"></param>
/// <param name="T0">ղοʱ</param>
/// <param name="doppler_para">ղ</param>
/// <returns>Ƶֵ</returns>
inline long double calNumericalDopplerValue(long double R,long double LightSpeed,long double T0, long double* doppler_para,int doppler_paramenter_number);

/// <summary>
/// ģͼƵֵ
/// </summary>
/// <param name="R">б</param>
/// <param name="lamda"></param>
/// <param name="R_sl">->ǵĿռ</param>
/// <param name="V_sl">->֮ٶ</param>
/// <returns>Ƶֵ</returns>
inline long double calTheoryDopplerValue(long double R, long double lamda, VectorPoint R_sl, VectorPoint V_sl);

/// <summary>
/// ݵӦsarӰ
/// </summary>
/// <param name="landpoint">--عϵ</param>
/// <param name="Starttime">ӰƬʼʱ</param>
/// <param name="lamda"></param>
/// <param name="T0">ղοʱ</param>
/// <param name="LightSpeed"></param>
/// <param name="delta_t">ʱ</param>
/// <param name="R0">б</param>
/// <param name="delta_R">б</param>
/// <param name="SatelliteModelStartTime">ǹģʱ</param>
/// <param name="polySatellitePara">ǹģͲ</param>
/// <param name="polynum">ǹģ</param>
/// <param name="doppler_paramenter_number">ģ</param>
/// <returns>Ӱ꣨x:кţy:кţzʱ̣</returns>
inline point PSTN(point& landpoint, long double Starttime, long double lamda, long double T0, long double* doppler_para, long double LightSpeed, long double delta_t, long double R0, long double delta_R, long double SatelliteModelStartTime, long double* polySatellitePara, int polynum = 4, int doppler_paramenter_number = 5);



struct translateArray {
	long double a0, a1, a2;
	long double b0, b1, b2;
};
/// <summary>
///  תӰ
/// </summary>
/// <param name="row_ids"></param>
/// <param name="col_ids"></param>
/// <param name="value"></param>
/// <param name="gt"></param>
/// <returns></returns>
inline point Translation(long double row_ids,long double col_ids,long double value,translateArray& gt) {

	point result{ 0,0,0 };
	result.x = gt.a0 + gt.a1 * col_ids + gt.a2 * row_ids;
	result.y = gt.b0 + gt.b1 * col_ids + gt.b2 * row_ids;
	result.z = value;
	return result;
}

inline int Translation(long double& x, long double& y, long double& r, long double& c, translateArray& gt) {

	c = gt.a0 + gt.a1 * x + gt.a2 * y;
	r = gt.b0 + gt.b1 * x + gt.b2 * y;
	return 0;
}

/// <summary>
/// dem
/// </summary>
class dem_block {

public:
	dem_block(int all_start_row,int all_start_col,int start_row, int end_row, int start_col, int end_col, int height, int width,int sample_f);
	dem_block(const dem_block& demblocks);
	~dem_block();
	dem_block resample_dem();
	//dem_block resample_dem_cudic();
	int rowcol2blockids(int row_ids, int col_ids);
	point getpointblock(int row_ids, int col_ids);
	int setpointblock(int row_ids, int col_ids, point& value);
	point getpointblock(int ids);
	int setpointblock(int ids, point& value);
	int UpdatePointCoodinarary();
	VectorPoint getslopeVector(int row_ids, int col_ids);
public:
	int all_start_row;
	int all_start_col;
	int start_row; // Ŀʼк 
	int end_row; //
	int start_col; // Ŀʼк
	int end_col;
	int height; 
	int width;
	int size;
	int sample_f;
	point* pointblock; // ԭʼ
};



inline point bilineadInterpolation(point& p,point& p11,point& p12,point& p21,point& p22);

inline point cubicInterpolation(point& p, point& p11, point& p12,point& p13,point& p14, point& p21, point& p22,point& p23,point& p24,point& p31,point& p32,point& p33,point& p34,point& p41,point& p42,point& p43,point& p44);

/// <summary>
/// ˫Բֵ
/// </summary>
/// <param name="p"></param>
/// <param name="p11"></param>
/// <param name="p12"></param>
/// <param name="p21"></param>
/// <param name="p22"></param>
/// <returns></returns>
inline point SARbilineadInterpolation(point& p, point& p11, point& p12, point& p21, point& p22) {




}
/// <summary>
///  -- 
/// </summary>
struct IncidenceAngle
{
	long double incidenceAngle; // ״
	long double localincidenceAngle; // ֵ
};

struct matchPoint {
	long double r, c, ti;
	long double land_x, land_y, land_z;
	long double distance;
	long double incidenceAngle, localincidenceAngle;
};
/// <summary>
///  ģsar ľ飬ۼģĬʹshort (ۼޣ
/// </summary>
class sim_block {
public:
	sim_block(int start_row,int end_row,int start_col,int end_col,int height,int width);
	sim_block(const sim_block& sim_blocks);
	~sim_block();

	int rowcol2blockids(int row_ids, int col_ids);
	short getsimblock(int row_ids, int col_ids);
	int setsimblock(int row_ids,int col_ids, short value);
	int addsimblock(int row_ids, int col_ids,short value);
	matchPoint getpointblock(int row_ids,int col_ids);
	int setpointblock(int row_ids, int col_ids, matchPoint value);
	// 
	long double getdistanceblock(int row_ids, int col_ids);
	int setdistanceblock(int row_ids, int col_ids, long double value);

public:
	int start_row;
	int end_row;
	int start_col;
	int end_col;
	int height;
	int width;
	int size;
	short* block;
	long double* distanceblock;
	matchPoint* pointblock; 
};


/// <summary>
/// ꣬꣬淨Ӧ״Ǻ;ֵ
/// </summary>
/// <param name="satellitepoint">ǿռ</param>
/// <param name="landpoint"></param>
/// <param name="slopvector">¶</param>
/// <returns>ļ</returns>
inline IncidenceAngle calIncidence(point satellitepoint,point landpoint,VectorPoint slopvector) {
	
	IncidenceAngle result;
	VectorPoint R_ls = getVector(landpoint, satellitepoint);
	result.localincidenceAngle = getVectorAngleValue(R_ls, slopvector);
	VectorPoint R_s{ satellitepoint.x,satellitepoint.y,satellitepoint.z };
	result.incidenceAngle = getVectorAngleValue(R_s, R_ls);
	return result;
}


int SimProcessBlock(dem_block demblock, ParameterInFile paras, matchPoint* result_shared, int* Pcount);

int ResamplingSim(ParameterInFile paras);
int ResampleGDAL(const char* pszSrcFile, const char* pszOutFile, float fResX, float fResY, GDALResampleAlg eResample);

/// <summary>
/// ģsarĴ㷨ģ顣
/// Ϊ˿ڴȡ
/// ߳8 --Խķʽй--ʹöеķ
/// ߳ڴ棺dem_block_size*sample_f*sample_f< 1 G
/// </summary>
/// <param name="paras">ļ</param>
/// <param name="thread_num">߳ĬΪ8</param>
/// <returns>ִ</returns>
int SimProcess(ParameterInFile paras, int thread_num);
int SimProcess_LVY(ParameterInFile paras, int thread_num);
int WriteMatchPoint(string path, std::vector<matchPoint>* matchps);
// Ժӿ

int testPTSN(ParameterInFile paras);


///
///
///  ӰĲֵ
/// 
/// 

class ConvertResampleParameter {
public:
	ConvertResampleParameter(string path);
	ConvertResampleParameter(const ConvertResampleParameter& para);
	~ConvertResampleParameter();
public:
	string in_ori_dem_path;
	string ori_sim;
	string out_sar_xyz_path;
	string out_sar_xyz_incidence_path;
	string out_orth_sar_incidence_path; 
	string out_orth_sar_local_incidence_path;
	string outFolder_path;
	int file_count;
	std::vector<string> inputFile_paths;
	std::vector<string> outFile_paths;
	std::vector<string> outFile_pow_paths;
	int ori2sim_num;
	long double* ori2sim_paras;
	int sim2ori_num;
	long double* sim2ori_paras;
};

inline int ori2sim(long double ori_x,long double ori_y,long double& sim_x,long double& sim_y,long double* conver_paras) {
	long double xy = ori_x * ori_y;
	long double x2 = ori_x * ori_x;
	long double y2 = ori_y * ori_y;

	sim_x = conver_paras[0] + ori_x * conver_paras[1] + ori_y * conver_paras[2] + x2 * conver_paras[3] + y2 * conver_paras[4] + xy * conver_paras[5];
	sim_y = conver_paras[6] + ori_x * conver_paras[7] + ori_y * conver_paras[8] + x2 * conver_paras[9] + y2 * conver_paras[10] + xy * conver_paras[11];
	return 1;
}

/// <summary>
/// ģкתΪĿк
/// </summary>
/// <param name="sim_r">ģк</param>
/// <param name="sim_c">ģк</param>
/// <param name="ori_r">Ŀк</param>
/// <param name="ori_c">Ŀк</param>
/// <param name="conver_paras">任</param>
/// <returns>Ĭϣ0 ʾ</returns>
inline int  sim2ori(long double sim_r,long double sim_c,long double& ori_r,long double& ori_c, long double* conver_paras) {
	long double xy = sim_r * sim_c;
	long double x2 = sim_r * sim_r;
	long double y2 = sim_c * sim_c;
	ori_r = conver_paras[0] + sim_r * conver_paras[1] + sim_c * conver_paras[2] + x2 * conver_paras[3] + y2 * conver_paras[4] + xy * conver_paras[5];
	ori_c = conver_paras[6] + sim_r * conver_paras[7] + sim_c * conver_paras[8] + x2 * conver_paras[9] + y2 * conver_paras[10] + xy * conver_paras[11];
	return 0;
}

// ѯȷ

point GetOriRC(point& landp, ParameterInFile& paras, ConvertResampleParameter& convparas);

int SimProcessBlock_CalXYZ(dem_block demblock, ParameterInFile paras, ConvertResampleParameter converParas, matchPoint* result_shared, int* Pcount);
int SimProcess_CalXYZ(ParameterInFile paras, ConvertResampleParameter conveparas, int thread_num);


/*
 ģ˼·
 dem->sim->ori(r,c) <-ز-> ori 
 step1: dem Ӧ ori ꣬-> ori_sim.tif  (r,c,incidence,localincidence)  
 step2: ݽֵӦa,b

*/
int SimProcess_Calsim2ori(ParameterInFile paras, ConvertResampleParameter conveparas, int thread_num); // ģ


/*
ز
step1ȡĿդ񣬲Ŀդ񴴽
step2: 
*/
int SimProcess_ResamplingOri2Orth(ParameterInFile paras, ConvertResampleParameter conveparas, int thread_num);

/*
ǿͼ
*/
int SimProcess_Calspow(ParameterInFile paras, ConvertResampleParameter conveparas, int thread_num); // ģ