#pragma once
///
/// ࡢ
/// 
//#define EIGEN_USE_MKL_ALL
//#define EIGEN_VECTORIZE_SSE4_2
//#include <mkl.h>

//#include <mkl.h>
#include <iostream>
#include <Eigen/Core>
#include <Eigen/Dense>
#include <time.h>
#include <string>
#include <omp.h>
#include <complex>
#include <gdal.h>
#include <gdal_priv.h>
#include <gdalwarper.h>
#include <ogrsf_frmts.h> 
#include <opencv2/opencv.hpp>
#include <opencv2/core/eigen.hpp>
#include <opencv2/features2d.hpp>
#include <fstream>


using namespace std;
using namespace Eigen;

#define PI_180 180/3.141592653589793238462643383279
#define T180_PI 3.141592653589793238462643383279/180
#define LIGHTSPEED 299792458


#define Radians2Degrees(Radians) Radians*PI_180
#define Degrees2Radians(Degrees) Degrees*T180_PI








const double PI = 3.141592653589793238462643383279;
const double epsilon = 0.000000000000001;
const double pi = 3.14159265358979323846;
const double d2r = pi / 180;
const double r2d = 180 / pi;

const double a = 6378137.0;		//򳤰
const double ae = 6378137.0;		//򳤰
const double ee= 0.0818191910428;// һƫ
const double f_inverse = 298.257223563;			//ʵ
const double b = a - a / f_inverse;
const double eSquare = (a * a - b * b) / (a * a);
const double e = sqrt(eSquare);
const double earth_Re = 6378136.49;
const double earth_Rp = (1 - 1 / f_inverse) * earth_Re;
const double earth_We = 0.000072292115;
///////////////////////////////////// ʱӡ  //////////////////////////////////////////////////////////


std::string getCurrentTimeString();
std::string getCurrentShortTimeString();


///////////////////////////////  ͼ     //////////////////////////////////////////////////////////

/// <summary>
/// ά
/// </summary>
struct Landpoint //     SARӰꣻ
{
	/// <summary>
	/// x
	/// </summary>
	double lon; // x lon pixel_col
	/// <summary>
	/// γy
	/// </summary>
	double lat; // γy lat pixel_row
	/// <summary>
	/// ߶z
	/// </summary>
	double ati; // ߳z ati pixel_time
};
struct Point_3d {
	double x;
	double y;
	double z;
};

Landpoint operator +(const Landpoint& p1, const Landpoint& p2);

Landpoint operator -(const Landpoint& p1, const Landpoint& p2);

bool operator ==(const Landpoint& p1, const Landpoint& p2);

Landpoint operator *(const Landpoint& p, double scale);

/// <summary>
/// A,Bļн,Ƕ
/// </summary>
/// <param name="a"></param>
/// <param name="b"></param>
/// <returns>Ƕ  0-360ȣʱ</returns>
double getAngle(const Landpoint& a, const Landpoint& b);

/// <summary>
/// 
/// </summary>
/// <param name="p1"></param>
/// <param name="p2"></param>
/// <returns></returns>
double dot(const Landpoint& p1, const Landpoint& p2);

double getlength(const Landpoint& p1);

Landpoint crossProduct(const Landpoint& a, const Landpoint& b);



struct DemBox {
	double min_lat; //γ
	double min_lon;//
	double max_lat;//γ
	double max_lon;//
};


/// <summary>
/// gdalImageͼ
/// </summary>
class gdalImage
{

public: // 
	gdalImage(string raster_path);
	~gdalImage();
	void setHeight(int);
	void setWidth(int);
	void setTranslationMatrix(Eigen::MatrixXd gt);
	void setData(Eigen::MatrixXd);
	Eigen::MatrixXd getData(int start_row, int start_col, int rows_count, int cols_count, int band_ids);
	void saveImage(Eigen::MatrixXd,int start_row,int start_col, int band_ids);
	void saveImage();
	void setNoDataValue(double nodatavalue,int band_ids);
	int InitInv_gt();
	Landpoint getRow_Col(double lon, double lat);
	Landpoint getLandPoint(double i, double j, double ati);
	double mean(int bandids=1);
	double max(int bandids=1);
	double min(int bandids=1);
	GDALRPCInfo getRPC();
	Eigen::MatrixXd getLandPoint(Eigen::MatrixXd points);

	Eigen::MatrixXd getHist(int bandids);
public:
	string img_path; // ͼļ
	int height; // 
	int width; // 
	int band_num;// 
	int start_row;// 
	int start_col;//
	int data_band_ids;
	Eigen::MatrixXd gt; // 任
	Eigen::MatrixXd inv_gt; // 任
	Eigen::MatrixXd data;
	string projection;
};

gdalImage CreategdalImage(string img_path, int height, int width, int band_num, Eigen::MatrixXd gt, std::string projection, bool need_gt=true);

void clipGdalImage(string in_path, string out_path, DemBox box, double pixelinterval);

int ResampleGDAL(const char* pszSrcFile, const char* pszOutFile, double* gt, int new_width, int new_height, GDALResampleAlg eResample);

int ResampleGDALs(const char* pszSrcFile, int band_ids, GDALRIOResampleAlg eResample=GRIORA_Bilinear);



///////////////////////////////  ͼ     //////////////////////////////////////////////////////////

string Convert(float Num);
std::string JoinPath(const std::string& path, const std::string& filename);

////////////////////////////// 겿ֻ //////////////////////////////////////////


/// <summary>
/// γתΪع̲ϵ
/// </summary>
/// <param name="XYZP">γȵ--degree</param>
/// <returns>ͶӰϵ</returns>
Landpoint LLA2XYZ(const Landpoint& LLA);
Eigen::MatrixXd LLA2XYZ(Eigen::MatrixXd landpoint);

/// <summary>
/// ع̲ϵתΪγ
/// </summary>
/// <param name="XYZ">̲ϵ</param>
/// <returns>γ--degree</returns>
Landpoint XYZ2LLA(const Landpoint& XYZ);


////////////////////////////// 겿ֻ //////////////////////////////////////////

/// <summary>
/// ر¶
/// </summary>
/// <param name="p0">̲ϵ</param>
/// <param name="p1">̲ϵ</param>
/// <param name="p2">̲ϵ</param>
/// <param name="p3">̲ϵ</param>
/// <param name="p4">̲ϵ</param>
/// <returns>Ƕ</returns>
//Landpoint getSlopeVector(Landpoint& p0, Landpoint& p1, Landpoint& p2, Landpoint& p3, Landpoint& p4, Eigen::MatrixXd UTC, double xp, double yp, double dut1, double dat);
Landpoint getSlopeVector(const Landpoint& p0, const Landpoint& p1, const Landpoint& p2, const Landpoint& p3, const Landpoint& p4);

//////////////////////////////  ֵ   ////////////////////////////////////////////

complex<double> Cubic_Convolution_interpolation(double u,double v,Eigen::MatrixX<complex<double>> img);

complex<double> Cubic_kernel_weight(double s);

double Bilinear_interpolation(Landpoint p0, Landpoint p11, Landpoint p21, Landpoint p12, Landpoint p22);



inline float cross2d(Point_3d a, Point_3d b) { return a.x * b.y - a.y * b.x; }

inline Point_3d operator-(Point_3d a, Point_3d b) {
	return Point_3d{ a.x - b.x, a.y - b.y, a.z - b.z };
};

inline Point_3d operator+(Point_3d a, Point_3d b) {
	return Point_3d{ a.x + b.x, a.y +b.y, a.z + b.z };
};

inline double operator/(Point_3d a, Point_3d b) {
	return sqrt(pow(a.x,2)+ pow(a.y, 2))/sqrt(pow(b.x, 2)+ pow(b.y, 2));
};
inline bool onSegment(Point_3d Pi, Point_3d Pj, Point_3d Q)
{
	if ((Q.x - Pi.x) * (Pj.y - Pi.y) == (Pj.x - Pi.x) * (Q.y - Pi.y)  // 
		//֤Qpi,pj֮ 
		&& min(Pi.x, Pj.x) <= Q.x && Q.x <= max(Pi.x, Pj.x)
		&& min(Pi.y, Pj.y) <= Q.y && Q.y <= max(Pi.y, Pj.y))
		return true;
	else
		return false;
}

inline Point_3d invBilinear(Point_3d p, Point_3d a, Point_3d b, Point_3d c, Point_3d d)
{
	Point_3d res ;

	Point_3d e = b - a;
	Point_3d f = d - a;
	Point_3d g = a - b + c - d;
	Point_3d h = p - a;

	double k2 = cross2d(g, f);
	double k1 = cross2d(e, f) + cross2d(h, g);
	double k0 = cross2d(h, e);
	double u, v;
	// if edges are parallel, this is a linear equation
	if (abs(k2) < 0.001)
	{
		v = -k0 / k1;
		u = (h.x  - f.x *v) / (e.x + g.x *v);
		p.z = a.z + (b.z - a.z) * u + (d.z - a.z) * v + (a.z - b.z + c.z - d.z) * u * v;
		return p;
	}
	// otherwise, it's a quadratic
	else
	{
		float w = k1 * k1 - 4.0 * k0 * k2;
		if (w < 0.0){
			// ڱ߽
			if (onSegment(a, b, p)) {
				Point_3d tt = b - a;
				Point_3d ttpa = p - a;
				double scater=ttpa / tt;
				if(scater<0||scater>1){ return { -9999,-9999,-9999 }; }
				p.z = a.z + scater * tt.z;
				return p;
			}
			else if (onSegment(b, c, p)) {
				Point_3d tt = c-b;
				Point_3d ttpa = p - b;
				double scater = ttpa / tt;
				if (scater < 0 || scater>1) { return { -9999,-9999,-9999 }; }
				p.z = b.z + scater * tt.z;
				return p;
			}
			else if (onSegment(c, d, p)) {
				Point_3d tt = d-c;
				Point_3d ttpa = p - c;
				double scater = ttpa / tt;
				if (scater < 0 || scater>1) { return { -9999,-9999,-9999 }; }
				p.z = c.z + scater * tt.z;
				return p;
			}
			else if (onSegment(d, a, p)) {
				Point_3d tt = a-d;
				Point_3d ttpa = p - d;
				double scater = ttpa / tt;
				if (scater < 0 || scater>1) { return { -9999,-9999,-9999 }; }
				p.z = d.z + scater * tt.z;
				return p;
			}

			return { -9999,-9999,-9999 };
		}
		else {
			w = sqrt(w);

			float ik2 = 0.5 / k2;
			float v = (-k1 - w) * ik2;
			float u = (h.x - f.x * v) / (e.x + g.x * v);

			if (u < 0.0 || u>1.0 || v < 0.0 || v>1.0)
			{
				v = (-k1 + w) * ik2;
				u = (h.x - f.x * v) / (e.x + g.x * v);
			}
			p.z = a.z + (b.z - a.z) * u + (d.z - a.z) * v + (a.z - b.z + c.z - d.z) * u * v;
			return p;
		}
	}
	p.z = a.z + (b.z - a.z) * u + (d.z - a.z) * v + (a.z - b.z + c.z - d.z) * u * v;
	return p;
}



//
// WGS84 J2000 ϵı任
// οַhttps://blog.csdn.net/hit5067/article/details/116894616
// ַhttp://celestrak.org/spacedata/ 
// ļ
//		 a. Earth Orientation Parameter ļ http://celestrak.org/spacedata/EOP-Last5Years.csv
//       b. Space Weather Data  ļ http://celestrak.org/spacedata/SW-Last5Years.csv
// עļ2017-
/**
wgs84 ϵתJ2000 ϵ Ҫ 漰໥תһWGSΪ ʱ̵ t ,BLH
ת裺
step 1: WGS 84 תЭϵ
step 2: Эϵ תΪ˲ʱϵ
step 3: ˲ʱϵ תΪ ˲ʱϵ
step 4: ˲ʱϵ ת˲ʱƽ ϵ
step 5: ˲ʱƽϵתΪЭϵJ2000
**/


inline double sind(double degree) {
	return sin(degree * d2r);
}

inline double cosd(double d) {
	return cos(d * d2r);
}

/*
class WGS84_J2000
{
public:
	WGS84_J2000();
	~WGS84_J2000();

public:
	// step1  WGS 84 תЭϵ
	static Eigen::MatrixXd WGS84TECEF(Eigen::MatrixXd WGS84_Lon_lat_ait);
	//step 2  Эϵ תΪ˲ʱϵ
	static Eigen::MatrixXd ordinateSingleRotate(int axis, double angle_deg);
	// step 3  ˲ʱϵ תΪ ˲ʱϵ 
	// xyz= ordinateSingleRotate('z',-gst_deg)*earthFixedXYZ;
	static int utc2gst(Eigen::MatrixXd UTC, double dUT1, double dAT, double& gst_deg, double& JDTDB);
	// step 4 ˲ʱϵ ת˲ʱƽ ϵ
	static int nutationInLongitudeCaculate(double JD, double& epthilongA_deg, double& dertaPthi_deg, double& dertaEpthilong_deg, double& epthilong_deg);
	// step5  ˲ʱƽϵתΪЭϵJ2000 JDTDB Ϊʱ ĵѧʱӦգ㷽ɲеĺ
	// xyz=ordinateSingleRotate('Z',zetaA)*ordinateSingleRotate('y',-thitaA)*ordinateSingleRotate('z',zA)*xyz;
	static int precessionAngle(double JDTDB, double& zetaA, double& thitaA, double& zA);
	// YMD2JD ͬʱ YMD2JDΪ תΪգ˵ Ԫ귨-ת_${С}Ĳ-CSDN_ռ㹫ʽ
	static double YMD2JD(double y, double m, double d);
	static Eigen::MatrixXd WGS842J2000(Eigen::MatrixXd BLH_deg_m, Eigen::MatrixXd UTC, double xp, double yp, double dut1, double dat);
	static Landpoint WGS842J2000(Landpoint LBH_deg_m, Eigen::MatrixXd UTC, double xp, double yp, double dut1, double dat);
public:
	static std::string EOP_File_Path;
	static std::string Space_Weather_Data;
	// IAU2000ģ7711
	static Eigen::Matrix<double, 77, 11> IAU2000ModelParams;
};

*/